# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class CreateManagedKey(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'alg': 'str',
        'managed_key_value': 'str',
        'metadata': 'str',
        'name': 'str',
        'protection_key': 'str',
        'tags': 'list[str]',
        'target_name': 'str',
        'token': 'str',
        'uid_token': 'str'
    }

    attribute_map = {
        'alg': 'alg',
        'managed_key_value': 'managed-key-value',
        'metadata': 'metadata',
        'name': 'name',
        'protection_key': 'protection_key',
        'tags': 'tags',
        'target_name': 'target-name',
        'token': 'token',
        'uid_token': 'uid-token'
    }

    def __init__(self, alg=None, managed_key_value=None, metadata=None, name=None, protection_key=None, tags=None, target_name=None, token=None, uid_token=None, local_vars_configuration=None):  # noqa: E501
        """CreateManagedKey - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._alg = None
        self._managed_key_value = None
        self._metadata = None
        self._name = None
        self._protection_key = None
        self._tags = None
        self._target_name = None
        self._token = None
        self._uid_token = None
        self.discriminator = None

        self.alg = alg
        if managed_key_value is not None:
            self.managed_key_value = managed_key_value
        if metadata is not None:
            self.metadata = metadata
        self.name = name
        if protection_key is not None:
            self.protection_key = protection_key
        if tags is not None:
            self.tags = tags
        if target_name is not None:
            self.target_name = target_name
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token

    @property
    def alg(self):
        """Gets the alg of this CreateManagedKey.  # noqa: E501

        Managed Key type; options: [AES256GCM, RSA2048]  # noqa: E501

        :return: The alg of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._alg

    @alg.setter
    def alg(self, alg):
        """Sets the alg of this CreateManagedKey.

        Managed Key type; options: [AES256GCM, RSA2048]  # noqa: E501

        :param alg: The alg of this CreateManagedKey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and alg is None:  # noqa: E501
            raise ValueError("Invalid value for `alg`, must not be `None`")  # noqa: E501

        self._alg = alg

    @property
    def managed_key_value(self):
        """Gets the managed_key_value of this CreateManagedKey.  # noqa: E501

        Base64-encoded managed key value  # noqa: E501

        :return: The managed_key_value of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._managed_key_value

    @managed_key_value.setter
    def managed_key_value(self, managed_key_value):
        """Sets the managed_key_value of this CreateManagedKey.

        Base64-encoded managed key value  # noqa: E501

        :param managed_key_value: The managed_key_value of this CreateManagedKey.  # noqa: E501
        :type: str
        """

        self._managed_key_value = managed_key_value

    @property
    def metadata(self):
        """Gets the metadata of this CreateManagedKey.  # noqa: E501

        Metadata about the managed key  # noqa: E501

        :return: The metadata of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this CreateManagedKey.

        Metadata about the managed key  # noqa: E501

        :param metadata: The metadata of this CreateManagedKey.  # noqa: E501
        :type: str
        """

        self._metadata = metadata

    @property
    def name(self):
        """Gets the name of this CreateManagedKey.  # noqa: E501

        ManagedKey name  # noqa: E501

        :return: The name of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateManagedKey.

        ManagedKey name  # noqa: E501

        :param name: The name of this CreateManagedKey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def protection_key(self):
        """Gets the protection_key of this CreateManagedKey.  # noqa: E501

        The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)  # noqa: E501

        :return: The protection_key of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._protection_key

    @protection_key.setter
    def protection_key(self, protection_key):
        """Sets the protection_key of this CreateManagedKey.

        The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)  # noqa: E501

        :param protection_key: The protection_key of this CreateManagedKey.  # noqa: E501
        :type: str
        """

        self._protection_key = protection_key

    @property
    def tags(self):
        """Gets the tags of this CreateManagedKey.  # noqa: E501

        List of the tags attached to this managed key  # noqa: E501

        :return: The tags of this CreateManagedKey.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CreateManagedKey.

        List of the tags attached to this managed key  # noqa: E501

        :param tags: The tags of this CreateManagedKey.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def target_name(self):
        """Gets the target_name of this CreateManagedKey.  # noqa: E501

        Target name  # noqa: E501

        :return: The target_name of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._target_name

    @target_name.setter
    def target_name(self, target_name):
        """Sets the target_name of this CreateManagedKey.

        Target name  # noqa: E501

        :param target_name: The target_name of this CreateManagedKey.  # noqa: E501
        :type: str
        """

        self._target_name = target_name

    @property
    def token(self):
        """Gets the token of this CreateManagedKey.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this CreateManagedKey.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this CreateManagedKey.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this CreateManagedKey.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this CreateManagedKey.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this CreateManagedKey.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this CreateManagedKey.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateManagedKey):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateManagedKey):
            return True

        return self.to_dict() != other.to_dict()
